;Filename: ClkSpd.s
;Part: ADuC702x.
;Created: 11/03/2004 at 11h58
;Updated: 28/06/2005
;Author: Eckart Hartmann.
;This file is in beta sampling.

#include        <ADuC702x.IAR.equ>

; ClkSpd==========Writes the CD bits and FINT bit.
; C Function prototype: int ClkSpd(int iCD, int iFint);
;iCD:{0,1,2,3,4,5,6,7}          //CD bits.
;iFint:{0,1}                    //FINT bit.
; Description of Function: Writes iCD to the CD bits in POWCON.
; User interface:
;       Call ClkSpd with CD bits in iCD and FINT in iFint.
;       Returns 1 in r0.
; Robustness:  No known issues.
; Side effects: Corrupts r2 and r3.

                RSEG CODE
                MODULE ClkSpd
                PUBLIC ClkSpd
                CODE32


ClkSpd: and     r0,r0,#0x7              ;Strip CD bits
        and     r3,r1,#1                ; and FINT bit
        orr     r0,r0,r3,LSL#3          ; and combine.
        mov     r3,#0xff0000            ;r3 = Z_BASE;
        orr     r3,r3,#0xff000000
        ldr     r2,[r3,#Z_POWCON]       ;Get POWCON
        and     r2,r2,#0x0ff0           ; and remove old CD and FINT.
        orr     r0,r0,r2                ;Add new bits.
        mov     r2,#1                   ;Write POWCON with keys.
        str     r2,[r3,#Z_POWKEY1]
        str     r0,[r3,#Z_POWCON]
        mov     r2,#0xf4
        str     r2,[r3,#Z_POWKEY2]
        mov     r0,#1
        bx      lr                   ;return.


                 ENDMOD ClkSpd 

                 END
        
